<template>
  <main>
    <v-container>
      <h5 class="headline fw-300 grey--text">Games List</h5>
      <v-layout row wrap>
        <v-flex sm12>
          <v-card>
            <v-card-title primary-title>
              <v-layout row fill-height align-center>
                <!-- Main Heading -->
                <v-flex sm7>
                  <h6 class="title fw-400 mb-0">{{currentDate.format('MMMM D, YYYY')}}</h6>
                  <span class="grey--text">Creation Time</span>
                </v-flex>
                <!-- Date Filter -->
                <v-flex sm5>
                  <v-menu lazy full-width>
                    <v-text-field slot="activator" label="Filter Date" v-model="filterDate" append-icon="filter_list" readonly></v-text-field>
                    <v-date-picker v-model="filterDate"></v-date-picker>
                  </v-menu>
                </v-flex>
              </v-layout>
            </v-card-title>
            <!-- Games List -->
            <v-data-table
              :headers="headers"
              :items="games"
              :loading="loading"
              :no-data-text="loading ? 'Loading' : 'No games for this day.'"
              :rows-per-page-items="[10, 50, 100]">
              <template slot="items" scope="{item}">
                <tr>
                  <td>{{item.duration}}</td>
                  <td>{{$moment.unix(Math.round(item.startTime / 1000)).format('ddd, MMM D, YYYY h:mma')}}</td>
                  <td>{{$moment.unix(Math.round(item.endTime / 1000)).format('ddd, MMM D, YYYY h:mma')}}</td>
                  <td><v-icon>{{item.booked ? 'check_box' : 'check_box_outline_blank'}}</v-icon></td>
                  <td>{{item.price}}</td>
                  <td>{{item.payment_status}}</td>
                </tr>
              </template>
            </v-data-table>
          </v-card>
        </v-flex>
      </v-layout>
    </v-container>
  </main>
</template>

<script>
  export default {
    name: 'games-list',
    // Module Configuration
    data () {
      return {
        loading: true,
        currentDate: this.$moment(),
        headers: [
          {text: 'Duration', value: 'duration', align: 'left'},
          {text: 'Start Time', value: 'startTime', align: 'left'},
          {text: 'End Time', value: 'endTime', align: 'left'},
          {text: 'Booked', value: 'booked', align: 'left'},
          {text: 'Price', value: 'price', align: 'left'},
          {text: 'Payment Status', value: 'payment_status', align: 'left'}
        ],
        games: [],
        filterDate: null
      }
    },
    // Config Observer
    watch: {
      filterDate (to, from) {
        this.currentDate = this.$moment(to, 'YYYY-MM-DD')
        this.loading = true
        this.games = []
        this.loadGames()
      }
    },
    // Module Functions
    methods: {
      loadGames () {
        // Get `games` within the `currentDate`
        this.$database
          .ref('games')
          .orderByChild('startTime')
          /*
           * For `startAt` and `endAt` to work properly, mobile app should store timestamps as integer,
           * currently it is storing as a string. Also in the database, the value is a unix timestamp but
           * in miliseconds (Date.now()). Unix in seconds format is recommended (moment().unix()).
           * As a work arround, `currentDate` will be multiplied by 1000.
           */
          .startAt(this.currentDate.startOf('day').unix() * 1000)
          .endAt(this.currentDate.endOf('day').unix() * 1000)
          .limitToLast(100)
          .once('value')
          .then(snapshot => {
            let games = snapshot.val()

            if (games) {
              Object.keys(games).forEach(game => {
                // Check if there is a booked game
                this.$database.ref('game_details').orderByChild('game_id').equalTo(game).once('value').then(snapshot => {
                  games[game].key = game
                  games[game].booked = !!snapshot.val()
                  this.games.push(games[game])
                  this.loading = false
                })
              })
            } else this.loading = false
          })
      }
    },
    // Initialization Block
    created () {
      this.loadGames()
      window.loadGames = this.loadGames
    }
  }
</script>

<style scoped>
  tr:hover {
    cursor: pointer;
  }
</style>
